PAGE    82,132
COMMENT *
         Auteur Franck PISSOTTE


        C       condense
        D       double passage
        E       elongue
        F       fin de papier
        G       caracteres gras
        H       code hexadecimal
        I       interligne
        K       caracteres internationaux
        L       passer une ligne
        P       passer une page
        S       caracteres indices
        T       tabulation
        U       ecriture unidirectionnelle
        Z       reinitialisation
        /       caractere
        "       chaine

        *


CSEG    SEGMENT

        ASSUME  CS:CSEG,DS:CSEG,ES:CSEG

        ORG     100H

PROG    PROC    FAR

param   equ     80h     ;parametres msdos

DEBUT:  PUSH    DS       ;initialisations
        XOR     AX,AX
        PUSH    AX
        MOV     AX,CS
        MOV     DS,AX
        MOV     ES,AX
        CLD

        MOV     SI,param    ;pointe sur la chaine de parametres
pr0:    LODSB
        OR      AL,AL       ;test si chaine vide
        JZ      OPTMAN      ;les options ne sont pas indiquees
        MOV     AH,0
        MOV     CX,AX       ;CX=longueur chaine
PR1:    LODSB         ;passer les blancs en tete
        CMP     AL,' '
        JNZ     PR2
        LOOP    PR1

OPTMAN: MOV     DX,OFFSET MES3 ;on affiche l'cran d'aide
        mov     ah,9
        int     21h
        mov     si,param
        mov     byte ptr [si],70 ;taille max parametres
        inc     si
        mov     ah,0AH
        mov     dx,param
        int     21h     ;on saisi les option au clavier
        cmp     byte ptr [si],0 ;si pas d'options on sort
        jz      retour
        jmp     pr0

EXIT:   MOV     AH,9        ;sortir et afficher message
        INT     21H
retour: RET

PR6:    JCXZ    RETOUR      ;passer les blancs de debut
PR3:    LODSB
        CMP     AL,' '
        JNZ     PR2
PR4:    LOOP    PR3
        JMP     RETOUR

PR2:    CALL    MAJ     ;convertir les minuscules

        DEC     CX       ;une option a ete prise
        PUSH    CX
        MOV     CX,CODADR-CODES
        MOV     DI,OFFSET CODES
        REPNZ   SCASB
        JNZ     OPTINC0     ;option inconnue
        MOV     BX,CX
        SHL     BX,1
        POP     CX
        JMP     CODADR[BX]  ;CX=Nombres de caracteres restant
                            ;    dans la chaine de commande
                            ;SI=pointe sur prochain car


OPTINC0:POP     CX
OPTINC: MOV     DX,OFFSET MES1      ;option illegale
        JMP     EXIT


CARACT: JCXZ    PARILL      ;caracteres internationaux
        LODSB
        CMP     AL,'0'
        JB      PARILL
        CMP     AL,'7'
        JA      PARILL
        SUB     AL,'0'
        CALL    ESCAP
        MOV     DL,'R'
        CALL    IMP
        MOV     DL,AL
        CALL    IMP
        JMP     PR4

INTERL: JCXZ    PARILL      ;espacement ligne
        LODSB
        CMP     AL,'6'
        JZ      L6
        CMP     AL,'8'
        JNZ     PARILL
        CALL    ESCAP
        MOV     DL,'0'
        CALL    IMP
        JMP     PR4
L6:     CALL    ESCAP
        MOV     DL,'2'
        CALL    IMP
        JMP     PR4

HEXA:   JCXZ    PARILL      ;codes hexa
        DEC     CX
        JCXZ    PARILL
        LODSB
        CALL    CHEXAL
        JC      PARILL
        MOV     DL,AL
        LODSB
        CALL    CHEXAL
        JC      PARILL
        push    cx
        MOV     CL,4
        SHL     DL,CL
        pop     cx
        OR      DL,AL

        CALL    IMP
        JMP     PR4

PARILL: MOV     DX,OFFSET MES2
        JMP     EXIT

TABUL:  JCXZ    PARILL      ;tabulations
        LODSB
        CALL    CHIFR
        JC      PARILL
        SUB     AL,'0'
        MOV     AH,AL
        CALL    ESCAP
        MOV     DL,'D'
        CALL    IMP
        OR      AL,AL
        JZ      TABFIN
        push    cx
        MOV     CX,12
TABREP: MOV     DL,AL
        CALL    IMP
        ADD     AL,AH
        LOOP    TABREP
        pop     cx
TABFIN: MOV     DL,0
        CALL    IMP
        JMP     PR4

char:   jcxz    parill
        lodsb
        mov     dl,al
        call    imp
        jmp     pr4

string: jcxz    parill
stri1:  lodsb
        cmp     al,'"'
        jnz     stri2
        jmp     pr4
stri2:  mov     dl,al
        call    imp
        loop    stri1
        jmp     retour

ZERO:   CALL    ESCAP       ;reinitialisation
        MOV     DL,'@'
        CALL    IMP
        JMP     PR6

UNIDIR: CALL    PLUSM       ;ecriture unidirectionnelle
        CALL    ESCAP
        MOV     DL,'U'
        CALL    IMP
        MOV     AH,0
        JMP     OFFON

SPAGE:  MOV     DL,12    ;saut de page
        CALL    IMP
        JMP     PR6

LIGNE:  MOV     AL,[SI]
        CMP     AL,'1'
        JB      LIGN
        CMP     AL,'9'
        JA      LIGN
        INC     SI
        SUB     AL,'0'
        MOV     AH,0
        push    cx
        MOV     CX,AX
LIGREP: MOV     DL,13
        CALL    IMP
        MOV     DL,10
        CALL    IMP
        LOOP    LIGREP
        pop     cx
        JMP     PR4

LIGN:   MOV     DL,13    ;passer a la ligne suivante
        CALL    IMP
        MOV     DL,10
        CALL    IMP
        JMP     PR6

GRAS:   CALL    PLUSM       ;caracteres gras
        CALL    ESCAP
        MOV     AH,45H
        JMP     ONOFF

FINPAP: CALL    PLUSM       ;detection fin de papier
        CALL    ESCAP
        MOV     AH,38H
        JMP     OFFON

ELARGI: CALL    PLUSM       ;CARACTERES ELONGUES
        CALL    ESCAP
        MOV     DL,57H
        CALL    IMP
        MOV     AH,0
        JMP     OFFON

DOUBLE: CALL    PLUSM       ;ECRITURE EN DOUBLE PASSAGE
        CALL    ESCAP
        MOV     AH,47H
        JMP     ONOFF

CONDENS:CALL    PLUSM       ;CARACTRES CONDENSES
        MOV     DL,15
        CMP     AL,'+'
        JZ      COND
        MOV     DL,18
COND:   CALL    IMP
        JMP     PR6

indice: call    plusm
        call    escap
        cmp     al,'+'
        jz      setind
        mov     dl,'T'
        call    imp
        jmp     pr6
setind: mov     dl,'S'
        call    imp
        mov     dl,01
        call    imp
        jmp     pr6

ONOFF:  CMP     AL,'-'
        JZ      OFF1
        JMP     OFF

OFFON:  CMP     AL,'-'
        JZ      OFF
OFF1:   INC     AH
OFF:    MOV     DL,AH
        CALL    IMP
        JMP     PR6

PROG    ENDP

PLUSM   PROC    NEAR        ;tester si option + ou -

        JCXZ    PLUS0       ;retour si fin de chaine parametre
        LODSB
        CMP     AL,'+'
        JZ      PLUS1
        CMP     AL,'-'
        JZ      PLUS1
        DEC     SI      ;si ni '+' ni '-' '+' est pris par defaut
PLUS0:  MOV     AL,'+'
        RET
PLUS1:  DEC     CX
        RET

PLUSM   ENDP

MAJ     PROC    NEAR        ;converti AL en majuscule

        CMP     AL,'a'
        JB      MAJRET
        CMP     AL,'z'
        JA      MAJRET
        SUB     AL,32
MAJRET: RET

MAJ     ENDP

CHIFR   PROC    NEAR

        CMP     AL,'0'
        JB      CHIFILL
        CMP     AL,'9'
        JA      CHIFILL
        CLC
        RET
CHIFILL:STC
        RET

CHIFR   ENDP

CHEXAL  PROC    NEAR       ;converti AL en binaire

        CMP     AL,'0'
        JB      HEXILL
        CMP     AL,'9'
        JA      HEXLET
        SUB     AL,'0'
        RET
HEXLET: CALL    MAJ
        CMP     AL,'A'
        JB      HEXILL
        CMP     AL,'F'
        JA      HEXILL
        SUB     AL,'A'-10
        RET
HEXILL: STC
        RET

CHEXAL  ENDP

ESCAP   PROC    NEAR

        MOV     DL,27

ESCAP   ENDP

IMP     PROC    NEAR        ;imprime DL

        PUSH    AX
        MOV     AH,5
        INT     21H
        POP     AX
        RET

IMP     ENDP

CODES   DB      'CDEFGHIKLPSTUZ/"'  ;tables codes et adresses
CODADR  DW      string
        DW      char
        DW      ZERO
        DW      UNIDIR
        DW      TABUL
        DW      INDICE
        DW      SPAGE
        DW      LIGNE
        DW      CARACT
        DW      INTERL
        DW      HEXA
        DW      GRAS
        DW      FINPAP
        DW      ELARGI
        DW      DOUBLE
        DW      CONDENS

MES1    DB  'Option inconnue',13,10,'$'
MES2    DB  'Paramtre illgal',13,10,'$'
MES3    DB  '==============================================================================',13,10
        DB  '    Programme MX.COM V1.6           |  CODES                ACTION',13,10
        DB  '    Cre    le 07/02/86             |=========================================',13,10
        DB  '    Modifi le 18/12/87             | C  C+ C-     Condens (20 cpi)',13,10
        DB  '    Auteur  Franck PISSOTTE         | D  D+ D-     Double passage',13,10
        DB  '                                    | E  E+ E-     Elongu  ( 6 cpi)',13,10
        DB  '====================================| F  F+ F-     Fin de papier',13,10
        DB  "Ce programme  permet  d'obtenir les | G  G+ G-     Gras",13,10
        DB  "modes  d'impression les plus utiles | H??          Hexadecimal ??=00  FF",13,10
        DB  'sur une imprimante EPSON.           | I6 I8        Interligne 6/8 lignes/pouce',13,10
        DB  '------------------------------------| K0 .. K7     Jeux caractres nationaux',13,10
        DB  'Exemple:  MX D G+ K1                | L  L1 .. L9  Ligne saute n lignes',13,10
        DB  'criture double passage caractres  | P            Page  saut de page',13,10
        DB  'gras et jeu de caractres franais. | S  S+ S-     Indices',13,10
        DB  '------------------------------------| T0 .. T9     Tabulation 12 espaces de n',13,10
        DB  'Espaces  entre options facultatifs. | U  U+ U-     Unidirectionnel',13,10
        DB  '+ ou rien active mode   - supprime. | Z            Zro Rinitialisation',13,10
        DB  'On  peut  utiliser  les  fonctions  | "?????"      Chaine de caractres',13,10
        DB  "d'dition du DOS pour  indiquer les | /?           Caractre ?=car",13,10
        DB  'options.                            |',13,10
        DB  '==============================================================================',13,10
        DB  'OPTIONS ?$'

CSEG   ENDS

        END     DEBUT
